/*

Copyright _ 2005, dana 'mania'
riverrunner@gmail.com
if you have any suggestions or improvements for this widget please let me know.

*/

//// GLOBAL VARS ////

var imgsrc = "images/test.jpg";
//var imgsrc = "http://www.goes.noaa.gov/GIFS/WCIR.JPG";
var satlocation = "WC";
var datatype = "IR";
var i = 0;

//// FUNCTIONS ////

function setup() {
	if(window.widget) {
		var checkprefs = widget.preferenceForKey("satlocation");
		if (checkprefs == undefined) { // save some prefs
			widget.setPreferenceForKey("WC","satlocation");
			widget.setPreferenceForKey("IR","datatype");
		} else { // get prefs
			satlocation = widget.preferenceForKey("satlocation");
			datatype = widget.preferenceForKey("datatype");
			imgsrc = "http://www.goes.noaa.gov/GIFS/"+satlocation+datatype+".JPG";
		}
		getdata();
		setInterval('getdata()', 1800000); // reload every 30 mins
	}
}

function savepref() {
	var satlocationindex = document.getElementById("satlocation").options.selectedIndex;
	var newsatlocation = document.getElementById("satlocation").options[satlocationindex].value;
	var datatypeindex = document.getElementById("datatype").options.selectedIndex;
	var newdatatype = document.getElementById("datatype").options[datatypeindex].value;
	widget.setPreferenceForKey(newsatlocation,"satlocation");
	widget.setPreferenceForKey(newdatatype,"datatype");
	setup();
}

function getdata() {
	i++;
	document.getElementById('bd').src='images/loading.png';
	document.getElementById('bd').src=imgsrc+'?'+i;
}

function reloader() {
	location.href='howgoesit.html';
}

// -------------------------------------------------------------------

// Anything below this point was taken from Apple's pref/flip routines

// -------------------------------------------------------------------

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);

	document.getElementById('fliprollie').style.display = 'none';
}


function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");
	
	back.style.display="none";
	front.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}


function makeKey(key)
{
	return (widget.identifier + "-" + key);
}


function removed()
{

	widget.setPreferenceForKey(null,makeKey("worldString"));
}


function focused()
{
	document.getElementById('worldText').style.color = 'white'; 
}


function blurred()
{
	document.getElementById('worldText').style.color = 'gray'; 
}


if(window.widget)
{
	widget.onremove = removed;
	window.onfocus = focused;
	window.onblur = blurred;
}	


var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};


function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}


function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}


function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}


function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}


function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}